package main

import (
	"fmt"
	"strings"
	"unicode/utf8"
)

// RemoveNonUTF8Chars 从字符串中剔除所有非UTF-8字符
func RemoveNonUTF8Chars(s string) string {
	var builder strings.Builder
	for len(s) > 0 {
		r, size := utf8.DecodeRuneInString(s)
		if r == utf8.RuneError && size == 1 {
			// 遇到了非UTF-8字符，跳过它
			s = s[1:]
		} else {
			// 有效的UTF-8字符，将其添加到结果字符串中
			builder.WriteString(s[:size])
			s = s[size:]
		}
	}
	return builder.String()
}

func main() {
	input := "Hello, 世界! \x80\x81\x82" // 包含非UTF-8字符 \x80\x81\x82
	output := RemoveNonUTF8Chars(input)
	fmt.Println(output) // 输出: Hello, 世界!
}
